-- mvh 20140629 replaced ImageDate and ImageNumber with new names

local query_pid = '';
local query_pna = '';
local query_pst = '';
local query_sta = '';
local studyuid = '';
local seriesUID = '';
local oiuid = '';

 
function mycomp(a,b)
    if a.PatientName == nil and b.PatientName == nil then
      return false
    end
    if a.PatientName == nil then
      return true
    end
    if b.PatientName == nil then
      return false
    end
    return a.PatientName < b.PatientName
end;
   
function InitializeVar()
 if (CGI('patientidmatch') ~='') then
     query_pid='*'..CGI('patientidmatch')..'*'
 else
  query_pid='*' 
 end

 if (patientnamematch ~= '') then
     query_pna='*'..CGI('patientnamematch')..'*' ;
 else 
  query_pna='*' 
 end

 if (CGI('studydatematch') ~= '') then
     query_pst='*'..CGI('studydatematch')..'*' ;
 else
   query_pst='*' 
 end

 if (CGI('startdatematch') ~= '') then
     query_sta='*'..CGI('startdatematch')..'*' ;
 else 
  query_sta='*' 
 end
 
end;
 


function mcoalesce(fff)
  if fff =='' or fff == nil then
    return '';
  end; 
 local res = tostring(fff);
 return res
end;
 
 
function queryimagem()
  local patis, q, b, s, pid, i, j, k, l, siuid;
 
  InitializeVar()
  s = servercommand('get_param:MyACRNema')

  q=CGI('query')
  i, j = string.find(q, "DICOMStudies.patientid = '")

  k, l = string.find(q, "' and")
  pid=(string.sub(q, j+1,k-1))       --> patientid
  
  i, j = string.find(q, "DICOMSeries.seriesinst = '")
  siuid=(string.sub(q, j+1))       --> seriesinst
  siuid = string.gsub(siuid, "'", '')
  --print(pid,siuid)

  b=newdicomobject();
  b.QueryRetrieveLevel='IMAGE'
  b.PatientID        = pid
  b.SeriesInstanceUID = siuid
  b.SOPInstanceUID   = '';
  b.InstanceNumber = '';
  b.SliceLocation = '';
  b.PatientName=''
  b.AcquisitionDate=''
  b.StudyInstanceUID ='' 
  images=dicomquery(s, 'IMAGE', b);
  
  -- convert returned DDO (userdata) to table; needed to allow table.sort
  imaget={}
  for k=0,#images-1 do
	  imaget[k+1]={}
	  imaget[k+1].SOPInstanceUID=images[k].SOPInstanceUID
    imaget[k+1].PatientID        = images[k].PatientID
	  imaget[k+1].AcquisitionDate        = images[k].AcquisitionDate
	  imaget[k+1].PatientName        = images[k].PatientName
    imaget[k+1].SeriesInstanceUID = images[k].SeriesInstanceUID
    imaget[k+1].StudyInstanceUID   = images[k].StudyInstanceUID
    imaget[k+1].InstanceNumber = images[k].InstanceNumber
    imaget[k+1].SliceLocation = images[k].SliceLocation
  end
  --table.sort(imaget, function(a,b) return a.SOPInstanceUID<b.SOPInstanceUID end)
  return imaget
end


HTML("Content-type: text/html\nCache-Control: no-cache\n");

print(
[[
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<title>Ortocenter DICOM server - version]]..version..[[</title>]]..
[[<style type="text/css">
body { font:10pt Verdana; }
a { color:blue; }
#content { background-color:#dddddd; width:200px; margin-top:2px; }
</style>
]]
)

print(
[[
<!-- Javascript goes in the document HEAD -->
<script type="text/javascript">
function altRows(id){
	if(document.getElementsByTagName){  
		
		var table = document.getElementById(id);  
		var rows = table.getElementsByTagName("tr"); 
		 
		for(i = 0; i < rows.length; i++){          
			if(i % 2 == 0){
				rows[i].className = "evenrowcolor";
			}else{
				rows[i].className = "oddrowcolor";
			}      
		}
	}
}
window.onload=function(){
	altRows('alternatecolor');
}
</script>

<!-- CSS goes in the document HEAD or added to your external stylesheet -->
<style type="text/css">
table.altrowstable {
	font-family: verdana,arial,sans-serif;
	font-size:16px;
	color:#333333;
	border-width: 1px;
	border-color: #a9c6c9;
	border-collapse: collapse;
}
table.altrowstable th {
	border-width: 1px;
	padding: 8px;
	border-style: solid;
	border-color: #a9c6c9;
}
table.altrowstable td {
	border-width: 1px;
	padding: 8px;
	border-style: solid;
	border-color: #a9c6c9;
}
.oddrowcolor{
	background-color:#d4e3e5;
}
.evenrowcolor{
	background-color:#c3dde0;
}
table.altrowstable tr:first-child {
	font-weight:bold;
}
table.altrowstable Caption {
    font-weight:bold;
    color: yellow;
    background: green;
}
</style>
</head> 
<body BGCOLOR='CFDFCF'>
]]
)


print(
[[
<SCRIPT type="text/javascript">
function PopupCenter(pageURL, title,w,h)
{ var left = (screen.width/2)-(w/2);
  var top = (screen.height/2)-(h/2);
  var targetWin = window.open (pageURL, title, 'toolbar=no, location=no, directories=no, status=no, menubar=no, scrollbars=no, resizable=no, copyhistory=no, width='+w+', height='+h+', top='+top+', left='+left);
}
</SCRIPT>
]]
)

print(
[[
<SCRIPT type="text/javascript">
function getTextSync(url,w,h)
{   
    var left = (screen.width/2)-(w/2);
    var top = (screen.height/2)-(h/2);
	var teste = "ola"
	var request = new XMLHttpRequest();  // Create new request
    request.open("GET", url, false);     // Pass false for synchronous
    request.send(null);                  // ok Send the request now
	
	if (request.status !== 200) throw new Error(request.statusText);
	var type = request.getResponseHeader("Content-Type")
	if (!type.match(/^text/))
	   throw new Error("Expected textual response; got: " + type);
	
	var newWindow = window.open("","Header",'toolbar=no, location=no, directories=no, status=no, menubar=no, scrollbars=yes, resizable=yes, copyhistory=no, width='+w+', height='+h+', top='+top+', left='+left);
	var text = request.responseText
	
	var html = '<html><head></head><body><H1>Header, </H1><b><pre>'+ text +"</pre></b>"
	
	html = html+"</body></html>"
	
	newWindow.document.open()
	newWindow.document.write(html)
	newWindow.document.close()
    //return request.responseText;
}
</SCRIPT>
]]
)


HTML("<H1>Welcome to the Conquest DICOM server - version %s</H1>", version)

local pats=queryimagem() 
table.sort(pats, function(a,b) return a.SOPInstanceUID<b.SOPInstanceUID end)
--table.sort(pats, mycomp)


print("<table class='altrowstable' id='alternatecolor' RULES=ALL BORDER=1>");
HTML("<Caption>List of images on local server (all)</caption>");
HTML("<TR><TD>Patient ID<TD>Name<TD>Date<TD>Image number<TD>Slice location<TD>Header</TR>");
	
local studyviewer=gpps('webdefaults', 'studyviewer', '');


for i=1,#pats do
  
  studyuid = pats[i].StudyInstanceUID;
  seriesUID = pats[i].SeriesInstanceUID;
  oiuid = pats[i].SOPInstanceUID;
	
  local url_header
  local url_img
	--url_header = '<A href="#" onClick="javascript:PopupCenter('.."'"..script_name
  url_header = '<A href="#" onClick="javascript:getTextSync('.."'"..script_name
  url_header = url_header .. '?requestType=WADO&contentType=text/html'
  url_header = url_header .. '&seriesUID=' .. seriesUID
  url_header = url_header .. '&studyUID=' .. studyuid
  url_header = url_header .. '&objectUID=' .. oiuid
  url_header = url_header .. "&dum=.txt', 500, 500)"..'">'
	
  url_img = '<A href="#" onClick="javascript:PopupCenter('.."'"..script_name
  url_img = url_img .. '?requestType=WADO&contentType=image/gif'
  url_img = url_img .. '&seriesUID=' .. seriesUID
  url_img = url_img .. '&studyUID=' .. studyuid
  url_img = url_img .. '&objectUID=' .. oiuid
  url_img = url_img .. "&dum=.txt', 'myframe', 500, 500)"..'" title="click to see images">'

  local t,v,s
  
  t = url_img..string.format("%s</A>",mcoalesce(pats[i].PatientID));
 
  v = url_header.."Header</A>";
  
  
  s = string.format("<TR><TD>%s<TD>%s<TD>%s<TD>%s<TD>%s<TD>%s</TR>",t,mcoalesce(pats[i].PatientName), 
            mcoalesce(pats[i].AcquisitionDate),mcoalesce(pats[i].InstanceNumber),  mcoalesce(pats[i].SliceLocation),v);
  print(s)
end 

print
[[
</table>
</body>
</html>
]]

