local  ex = '.exe'
local query_pid = '';
local query_pna = '';
local query_pst = '';
local query_sta = '';

function mycomp(a,b)
    if a.PatientName == nil and b.PatientName == nil then
      return false
    end
    if a.PatientName == nil then
      return true
    end
    if b.PatientName == nil then
      return false
    end
    return a.PatientName < b.PatientName
  end
  
function InitializeVar()
 if (CGI('patientidmatch') ~='') then
     query_pid='*'..CGI('patientidmatch')..'*'
 else
    q=CGI('query')
	i, j = string.find(q, "patientid = '")
    if j~=nil then
	 s=string.sub(q, j+1)
	 k, l = string.find(s, "'")
     pid=(string.sub(s, 1,l-1))       --> patientid
     if pid == nil or pid == '' then
	 query_pid=''
     else query_pid=pid
     end
   else	 query_pid=''
   end
 end
  
 if (patientnamematch ~= '') then
     query_pna='*'..CGI('patientnamematch')..'*' ;
 else 
  query_pna='' 
 end

 if (CGI('studydatematch') ~= '') then
     query_pst='*'..CGI('studydatematch')..'*' ;
 else
   query_pst='' 
 end

 if (CGI('startdatematch') ~= '') then
     query_sta='*'..CGI('startdatematch')..'*' ;
 else 
  query_sta='' 
 end
end;
 

function mcoalesce(fff)
  if fff =='' or fff == nil then
    return '';
  end; 
 local res = tostring(fff);
 return res
end;


function querystudy()
  local patis, b, s;
  
  InitializeVar()
  
  s = servercommand('get_param:MyACRNema')
  
  b=newdicomobject();
  b.QueryRetrieveLevel='STUDY'
  b['0008,0061']=''; --Modality
  b.StudyInstanceUID='' 
  b.PatientID=query_pid
  b.PatientName=query_pna
  b.StudyDate = query_pst
  b.StudyDescription=''

  patis=dicomquery(s, 'STUDY', b);
  
  patist={}
  for k1=0,#patis-1 do
	patist[k1+1]={}
	patist[k1+1].StudyInstanceUID = patis[k1].StudyInstanceUID
	patist[k1+1].StudyDate = patis[k1].StudyDate
	patist[k1+1].StudyTime = patis[k1].StudyTime
	patist[k1+1].StudyID = patis[k1].StudyID
	patist[k1+1].StudyDescription = patis[k1].StudyDescription
	patist[k1+1].AccessionNumber = patis[k1].AccessionNumber
	patist[k1+1].ReferPhysician = patis[k1].ReferPhysician
	patist[k1+1].PatientsAge = patis[k1].PatientsAge
	patist[k1+1].PatientsWeight = patis[k1].PatientsWeight
	patist[k1+1].StudyModality = patis[k1]['0008,0061'] 
	patist[k1+1].PatientName = patis[k1].PatientName
	patist[k1+1].PatientBirthDate = patis[k1].PatientBirthDate
	patist[k1+1].PatientSex = patis[k1].PatientSex
	patist[k1+1].PatientID = patis[k1].PatientID
  end
  return patist
end;


HTML("Content-type: text/html\nCache-Control: no-cache\n");

print(
[[
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<title>Ortocenter DICOM server - version]]..version..[[</title>]]..
[[<style type="text/css">
body { font:10pt Verdana; }
a { color:blue; }
#content { background-color:#dddddd; width:200px; margin-top:2px; }
</style>
]]
)

print(
[[
<!-- Javascript goes in the document HEAD -->
<script type="text/javascript">
function altRows(id){
	if(document.getElementsByTagName){  
		
		var table = document.getElementById(id);  
		var rows = table.getElementsByTagName("tr"); 
		 
		for(i = 0; i < rows.length; i++){          
			if(i % 2 == 0){
				rows[i].className = "evenrowcolor";
			}else{
				rows[i].className = "oddrowcolor";
			}      
		}
	}
}
window.onload=function(){
	altRows('alternatecolor');
}
</script>

<!-- CSS goes in the document HEAD or added to your external stylesheet -->
<style type="text/css">
table.altrowstable {
	font-family: verdana,arial,sans-serif;
	font-size:16px;
	color:#333333;
	border-width: 1px;
	border-color: #a9c6c9;
	border-collapse: collapse;
}
table.altrowstable th {
	border-width: 1px;
	padding: 8px;
	border-style: solid;
	border-color: #a9c6c9;
}
table.altrowstable td {
	border-width: 1px;
	padding: 8px;
	border-style: solid;
	border-color: #a9c6c9;
}
.oddrowcolor{
	background-color:#d4e3e5;
}
.evenrowcolor{
	background-color:#c3dde0;
}
table.altrowstable tr:first-child {
	font-weight:bold;
}
table.altrowstable Caption {
    font-weight:bold;
    color: yellow;
    background: green;
}
</style>
</head> 
<body BGCOLOR='CFDFCF'>
]]
)


HTML("<H1>Welcome to the Conquest DICOM server - version %s</H1>", version)
local pats=querystudy() 
if query_pna ~= '' then
  table.sort(pats, mycomp)
end


print("<table class='altrowstable' id='alternatecolor' RULES=ALL BORDER=1>");

if (query ~= '') then   
	print("<Caption>List of selected studies on local server</caption>")
else   
	print("<Caption>List of all studies on local server</caption>")
end

local studyviewer=gpps('webdefaults', 'studyviewer', '');

print("<TR><TD>Patient ID<TD>Name<TD>Study Date<TD>Study description<TD>Study modality</TR>"); 

for i=1,#pats do
  
  t = string.format("<A HREF=dgate%s?%s&mode=nh_queryseries&key=%s&query=DICOMStudies.patientid+=+'%s'+and+DICOMSeries.studyinsta+=+'%s' title='Click to see series'>%s</A>", ex, extra, tostring(key or ''),mcoalesce(pats[i].PatientID),mcoalesce(pats[i].StudyInstanceUID),mcoalesce(pats[i].PatientID));
  
  if (studyviewer ~= '') then
   u = string.format("<A HREF=dgate%s?%s&mode=%s&study=%s:%s&size=%s>Ver Imagens</A>", ex, tostring(extra or ''), tostring(studyviewer or ''),mcoalesce(pats[i].PatientID),mcoalesce(pats[i].StudyInstanceUID),size); 
  else
    u = 'No studyviewer'
  end
  s = string.format("<TR><TD>%s<TD>%s<TD>%s<TD>%s<TD>%s<TD>%s</TR>",t,mcoalesce(pats[i].PatientName),mcoalesce(pats[i].StudyDate),mcoalesce(pats[i].StudyDescription),mcoalesce(pats[i].StudyModality),u);
  print(s)
end 
	
print
[[
</table>
</body>
</html>
]]
