-- sample SOAP server

HTML('Content-type: text/xml\n\n');
require'LuaXml'
xfile=xml.load(uploadedfile)
os.remove(uploadedfile)

function soapstring(id, value)
  return {[1] = value; [0] = id; ["xsi:type"] = "xsd:string";}
end

function soapreturn(id, ...)
  return { [0] = "return";
           ["xsi:type"] = id;
	       ...
		 }
end

function soapresponse(t, id, val)
   t["soapenv:encodingStyle"] = "http://schemas.xmlsoap.org/soap/encoding/";
   t[0] = id;
   t[1] = val;
end

if xfile:find("urn:DeAnonymizeUID") then
   local NewUID = xfile:find("NewUID")[1];
   xfile[2][1]    = {}
   xfile[2][1]["soapenv:encodingStyle"] = "http://schemas.xmlsoap.org/soap/encoding/";
   xfile[2][1][0] = 'urn:DeAnonymizeUIDResponse';
   xfile[2][1][1] = {
     [1] = {
      [1] = servercommand('changeuidback:'..NewUID);
      [0] = "OriginalUID";
      ["xsi:type"] = "xsd:string";
     };
     [0] = "return";
     ["xsi:type"] = "urn:DeAnonymizeUIDResult";
    };
end

message = "urn:AnonymizeUID";
if xfile:find(message) then
   soapresponse(xfile:find(message),
                message .. 'Response',
                soapreturn(message .. 'Response',
				  soapstring("NewUID", servercommand('changeuid:'..xfile:find("OriginalUID")[1]))
			  )
               );
end


HTML(tostring(xfile));

